#if !defined  HAVE_FACT2PERM_SWP_APPLY_H__
#define       HAVE_FACT2PERM_SWP_APPLY_H__


#include "aux0/swap.h"
#include "fxttypes.h"

//#include "jjassert.h"


template <typename Type>
void ffact2perm_swp_apply(const ulong *fc, ulong n, Type *x)
// Permute x by permutation corresponding to ffact2perm_swp().
{
    for (ulong k=0; k<n-1; ++k)
    {
        ulong fa = fc[k];
        swap2( x[k], x[k+fa] );
    }
}
// -------------------------


template <typename Type>
void ffact2invperm_swp_apply(const ulong *fc, ulong n, Type *x)
// Permute x by permutation corresponding to ffact2invperm_swp().
{
    if ( n<=1 )  return;
    ulong k = n-2;
    do
    {
        ulong fa = fc[k];
        swap2( x[k], x[k+fa] );
    }
    while ( k-- );
}
// -------------------------


template <typename Type>
void rfact2perm_swp_apply(const ulong *fc, ulong n, Type *x)
// Permute x by permutation corresponding to rfact2perm_swp().
{
    for (ulong k=0,j=n-2; k<n-1; ++k,--j)
    {
        ulong fa = fc[k];
        swap2( x[j], x[j+fa] );
    }
}
// -------------------------


template <typename Type>
void rfact2invperm_swp_apply(const ulong *fc, ulong n, Type *x)
// Permute x by permutation corresponding to rfact2invperm_swp().
{
    if ( n<=1 )  return;
    ulong k = n-2, j=0;
    do
    {
        ulong fa = fc[k];
        swap2( x[j], x[j+fa] );
        ++j;
    }
    while ( k-- );
}
// -------------------------


#endif  // !defined HAVE_FACT2PERM_SWP_APPLY_H__
